/* ======================================================================
 * 
 * HH   HH         freevr.h
 * HH   HH         Author(s): Ed Peters, Bill Sherman
 * HHHHHHH         Created: June 20, 1998
 * HH   HH         Last Modified: May 28, 2003
 * HH   HH
 * 
 * Global header file for FreeVR application programs.
 *
 * TODO: We may want to refine (ie. limit) this to include only
 *   particular structures.
 *   [I'm not sure at the moment.]
 *
 * Copyright 2003, Bill Sherman & Friends, All Rights Reserved.
 * With the intent to provide an open-source license to be named later.
 * ====================================================================== */
#ifndef __FREEVR_H__
#define __FREEVR_H__

#include "vr_config.h"		/* includes vr_system.h->vr_context.h which includes version defines */
#include "vr_callback.h"
#include "vr_entity.h"
#include "vr_visren.h"
#include "vr_input.h"
#include "vr_math.h"
#include "vr_procs.h"
#include "vr_shmem.h"
#include "vr_debug.h"
#include "vr_utils.h"

/* for versions 0.4f & g */
#if (FREEVR_VERSION==000407) || (FREEVR_VERSION==000406)
#  define vrCreateLock	vrCreateLockOld
#endif

#ifdef PERFORMER
#include "vr_visren.pf.h"
#endif


/* NOTE: unfortunately there does not seem to be a way to get the filename */
/*   of the file that includes this "freevr.h" file.  The __FILE__ value   */
/*   will always report "freevr.h", which isn't very useful.               */
static	const char	*vrApplicationVersion = FREEVRVERSION
		" -- application compiled " __DATE__ " at " __TIME__
#ifdef HOST_NAME
		" on " HOST_NAME
#endif
#ifdef HOST
		" on " HOST
#endif
#ifdef ARCH
		"[" ARCH "]"
#endif
	"";

/* this function is here just to force the application */
/*   string to be included in the object file.         */
static void vrUnusedFunction()
{
	/* this line is to keep the compiler from printing a warning about an unused variable */
	vrApplicationVersion++;
}

#endif

